#include <atari.h>
#include <stdio.h>
#include <unistd.h>
#include "atari_multijoy.h"


/* FIXME: Will be part of atari.h's Page 0 labels */
#define SAVMSC (*(unsigned int*)0x58)

/* FIXME: Will be part of atari.h's Page 2 labels */
#define CRSINH (*(unsigned char*)0x2F0)
#define COLOR1 (*(unsigned char*)0x2C5)
#define COLOR2 (*(unsigned char*)0x2C6)

/* FIXME: Will be part of atari.h */
unsigned char * PAGE6 = (char *) (0x600);


void dli_init(void) {
  unsigned char i;
  unsigned char * DLIST;
  unsigned char old_sdmctl;

  old_sdmctl = multijoy_dli_init_1();

  DLIST = (unsigned char *) SDLST;

  DLIST[3] = DL_DLI(DL_LMS(DL_GRAPHICS0));
  for (i = 6; i < 29; i++) {
    DLIST[i] = DL_DLI(DL_GRAPHICS0);
  }

  multijoy_dli_init_2(old_sdmctl);
}


int main(void) {
  unsigned char p, s, xx, yy;
  unsigned char x[8], y[8];
  unsigned char * SC;

  multijoy_init(true);

  _graphics(0);
  CRSINH = 1;
  printf("%c", CH_CLR);
  COLOR1 = 15;
  COLOR2 = 0;

  dli_init();

  x[0] = 0;
  y[0] = 0;

  x[1] = 19;
  y[1] = 0;

  x[2] = 39;
  y[2] = 0;

  x[3] = 39;
  y[3] = 11;

  x[4] = 39;
  y[4] = 23;

  x[5] = 19;
  y[5] = 23;

  x[6] = 0;
  y[6] = 23;

  x[7] = 0;
  y[7] = 11;

  multijoy_wait();

  do {
    for (p = 0; p < 8; p++) {
      xx = x[p];
      yy = y[p];

      s = PAGE6[p];
      if (s != 15) {
        if (PAGE6[p + 8]) {
          SC = (char *) SAVMSC + yy * 40 + xx;
          *SC = 0;
        }

        if (!(s & JOY_UP_MASK) && yy > 0) {
          yy--;
        } else if (!(s & JOY_DOWN_MASK) && yy < 23) {
          yy++;
        }
        if (!(s & JOY_LEFT_MASK) && xx > 0) {
          xx--;
        } else if (!(s & JOY_RIGHT_MASK) && xx < 39) {
          xx++;
        }
      }

      SC = (char *) SAVMSC + yy * 40 + xx;
      *SC = p + 16;

      x[p] = xx;
      y[p] = yy;
    }
  } while (GTIA_READ.consol == 7);

  multijoy_init(false);

  return 0;
}
