#include <atari.h>
#include <stdio.h>
#include <unistd.h>
#include "atari_multijoy.h"

#define USE_DLI


/* FIXME: Will be part of atari.h's Page 0 labels */
/*
#define ROWCRS (*(unsigned char*)0x54)
#define COLCRS (*(unsigned int*)0x55)
*/
#define LMARGN (*(unsigned char*)0x52)
#define RMARGN (*(unsigned char*)0x53)
#define SAVMSC (*(unsigned int*)0x58)

/* FIXME: Will be part of atari.h's Page 2 labels */
#define CRSINH (*(unsigned char*)0x2F0)

/* FIXME: Will be part of atari.h */
unsigned char * PAGE6 = (char *) (0x600);





void dli_init(void) {
  unsigned char i;
  unsigned char * DLIST;
  unsigned char old_sdmctl;

  old_sdmctl = multijoy_dli_init_1();

  DLIST = (unsigned char *) SDLST;

  DLIST[3] = DL_DLI(DL_LMS(DL_GRAPHICS0));
  for (i = 6; i < 29; i++) {
    DLIST[i] = DL_DLI(DL_GRAPHICS0);
  }

  multijoy_dli_init_2(old_sdmctl);
}


int main(void) {
  unsigned char s, x;
  unsigned char * SC;

  multijoy_init(true);

  _graphics(0);
  CRSINH = 1;
  LMARGN = 0;
  RMARGN = 39;
  printf("%c", CH_CLR);

#ifdef USE_DLI
  dli_init();
#endif

  do {
    for (s = 0; s < 8; s++) {
      SC = (char *) SAVMSC + s;
#ifdef USE_DLI
      x = PAGE6[s];
      *SC = x;
      x = PAGE6[s + 8];
      SC += 40;
      *SC = x;
#else
      x = multijoy_read(s);
      *SC = (x & 0xF);
      SC += 40;
      *SC = (x >> 4);
#endif
    }
  } while (GTIA_READ.consol == 7);

  multijoy_init(false);

  return 0;
}
